unit Flog;

interface

uses
    Windows, SysUtils, Classes, Graphics, Math, Types,
    Creature;

type
    TFlog = class(TCreature)
    public
        constructor Create();
        procedure mDraw();   override;   //  `
    end;

implementation

(*
    ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        TFlog
    ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*)
constructor TFlog.Create();
const
    MAX_SPEED = 14;
begin
    inherited;
    fColor         := clLime;
    fSpeed         := MAX_SPEED;
end;

procedure TFlog.mDraw();

    //  ----------------------------------------
    procedure drawFillCircle(x, y: double; r: integer);
    begin
        aWorld.fCanvas.Ellipse(
            Round( x - fMagnification * r),          //  S (x, y) Ƃ~
            Round( y - fMagnification * r),
            Round( x + fMagnification * r) + 1,
            Round( y + fMagnification * r) + 1
        );
    end;
    //  ----------------------------------------

var
    xL, xR, vx, yL, yR, vy: double;
begin

    vx := fMagnification * cos(fAngle);
    vy := fMagnification * sin(fAngle);

    xL := fX + 28 * vx + 32 * vy;
    yL := fY + 28 * vy - 32 * vx;

    xR := fX + 28 * vx - 32 * vy;
    yR := fY + 28 * vy + 32 * vx;

    with aWorld.fCanvas do begin
        //  g
        Pen.Color   := clBlack;
        Brush.Color := clBlack;
        drawFillCircle( fX, fY, 40);
        drawFillCircle( xL, yL, 24);
        drawFillCircle( xR, yR, 24);
        //  {
        Brush.Color := fColor;
        drawFillCircle( fX, fY, 32);
        drawFillCircle( xL, yL, 16);
        drawFillCircle( xR, yR, 16);
        //  锒
        Brush.Color := clWhite;
        drawFillCircle( xL, yL, 12);
        drawFillCircle( xR, yR, 12);
        //  鍕
        Brush.Color := clBlack;
        drawFillCircle( xL + 8 * vx, yL + 8 * vy, 7);
        drawFillCircle( xR + 8 * vx, yR + 8 * vy, 7);
        //  @
        drawFillCircle( fX - 5 * vx + 8 * vy, fY - 5 * vy - 8 * vx, 3);
        drawFillCircle( fX - 5 * vx - 8 * vy, fY - 5 * vy + 8 * vx, 3);
    end;

end;


end.
