unit Snake;

interface

uses
    Windows, SysUtils, Classes, Graphics, Math, Types,
    Creature;

type
    TSnake = class(TCreature)
    public
        constructor Create();
        procedure mDraw();   override;   //  `
    end;

implementation

(*
    ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        TSnake
    ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*)
constructor TSnake.Create();
const
    MAX_SPEED = 10;
begin
    inherited;
    fColor         := RGB(  0, 204, 255);
    fSpeed         := MAX_SPEED;
end;

procedure TSnake.mDraw();

    //  ----------------------------------------
    procedure drawFillCircle(x, y: double; r: integer);
    begin
        aWorld.fCanvas.Ellipse(
            Round( x - fMagnification * r),          //  S (x, y) Ƃ~
            Round( y - fMagnification * r),
            Round( x + fMagnification * r) + 1,
            Round( y + fMagnification * r) + 1
        );
    end;
    //  ----------------------------------------

var
    xL, xR, vx, yL, yR, vy: double;
begin

    vx := fMagnification * cos(fAngle);
    vy := fMagnification * sin(fAngle);

    xL := fX + 28 * vx + 40 * vy;
    yL := fY + 28 * vy - 40 * vx;

    xR := fX + 28 * vx - 40 * vy;
    yR := fY + 28 * vy + 40 * vx;

    with aWorld.fCanvas do begin
        //  g
        Pen.Color   := clBlack;
        Brush.Color := clBlack;
        drawFillCircle( fX, fY, 40);
        drawFillCircle( xL, yL, 24);
        drawFillCircle( xR, yR, 24);
        //  {
        Brush.Color := fColor;
        drawFillCircle( fX, fY, 32);
        drawFillCircle( xL, yL, 16);
        drawFillCircle( xR, yR, 16);
        //  
        Brush.Color := clWhite;
        drawFillCircle( xL, yL, 20);
        drawFillCircle( xR, yR, 20);
        //  
        Brush.Color := clBlack;
        drawFillCircle( xL + 10 * vx, yL + 10 * vy, 8);
        drawFillCircle( xR + 10 * vx, yR + 10 * vy, 8);
        //  
        Brush.Color := clRed;
        drawFillCircle( (xL + xR) / 2  + 30 * vx, (yL + yR) / 2 + 30 * vy, 10);
    end;

end;

end.
